check container starting and SSHD inside it
[build.git] / vbuild-init-lxc.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 #shopt -s huponexit
5
6 COMMAND=$(basename $0)
7 DIRNAME=$(dirname $0)
8 BUILD_DIR=$(pwd)
9
10 # pkgs parsing utilities
11 PATH=$(dirname $0):$PATH export PATH
12 . build.common
13
14 DEFAULT_FCDISTRO=f16
15 DEFAULT_PLDISTRO=planetlab
16 DEFAULT_PERSONALITY=linux64
17 DEFAULT_IFNAME=eth0
18
19 COMMAND_VBUILD="vbuild-init-lxc.sh"
20 COMMAND_MYPLC="vtest-init-lxc.sh"
21
22 lxc_version="0.8.0-rc2"
23
24 function bridge_init () {
25
26     # turn on verbosity
27     set -x
28
29     # constant
30     INTERFACE_BRIDGE=br0
31
32     # Default Value for INTERFACE_LAN
33     INTERFACE_LAN=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
34
35
36     echo "========== $COMMAND: entering start - beg"
37     hostname
38     uname -a
39     ifconfig
40     netstat -rn
41     echo "========== $COMMAND: entering start - end"
42
43     # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
44     #
45     # another option would be to accept the all forward packages for
46     # bridged interface like: -A FORWARD -m physdev --physdev-is-bridged -j ACCEPT
47     sysctl net.bridge.bridge-nf-call-iptables=0
48     sysctl net.bridge.bridge-nf-call-ip6tables=0
49     sysctl net.bridge.bridge-nf-call-arptables=0
50
51     # take extra arg for ifname, if provided
52     [ -n "$1" ] && { INTERFACE_LAN=$1; shift ; }
53
54     #if we have already configured the same host_box no need to do it again
55     /sbin/ifconfig $INTERFACE_BRIDGE &> /dev/null && {
56         echo "Bridge interface $INTERFACE_BRIDGE already set up - $COMMAND start exiting"
57         return 0
58     }
59     /sbin/ifconfig $INTERFACE_LAN &>/dev/null || {
60         echo "Cannot use interface $INTERFACE_LAN - exiting"
61         exit 1
62     }
63
64     
65     #Getting host IP/masklen
66     address=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
67     [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $INTERFACE_LAN" ; exit 1 ; }
68
69 broadcast=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
70     [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $INTERFACE_LAN"
71
72     gateway=$(netstat -rn | grep '^0.0.0.0' | awk '{print $2;}')
73     [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
74
75     # creating the bridge
76     echo "Creating bridge INTERFACE_BRIDGE=$INTERFACE_BRIDGE"
77     brctl addbr $INTERFACE_BRIDGE
78     #brctl stp $INTERFACE_BRIDGE yes
79     brctl addif $INTERFACE_BRIDGE $INTERFACE_LAN
80     echo "Activating promiscuous mode INTERFACE_LAN=$INTERFACE_LAN"
81     /sbin/ifconfig $INTERFACE_LAN 0.0.0.0 promisc up
82     sleep 2
83     echo "Setting bridge address=$address broadcast=$broadcast"
84     # static
85     /sbin/ifconfig $INTERFACE_BRIDGE $address broadcast $broadcast up
86     sleep 1
87
88     #Reconfigure the routing table
89     echo "Configuring gateway=$gateway"
90     route add default gw $gateway
91
92     echo "========== $COMMAND: exiting start - beg"
93     ifconfig
94     netstat -rn
95     echo "========== $COMMAND: exiting start - end"
96
97
98 return 0
99
100 }
101
102
103 function failure () {
104     echo "$COMMAND : Bailing out"
105     exit 1
106 }
107
108 function cidr_notation () {
109
110 netmask=$1; shift
111 cidr=0
112 for i in $(seq 1 4) ; do
113     part=$(echo $netmask | cut -d. -f $i)
114     case $part in
115         "255") cidr=$((cidr + 8));;
116         "254") cidr=$((cidr + 7));;
117         "252") cidr=$((cidr + 6));;
118         "248") cidr=$((cidr + 5));;
119         "240") cidr=$((cidr + 4));;
120         "224") cidr=$((cidr + 3));;
121         "192") cidr=$((cidr + 2));;
122         "128") cidr=$((cidr + 1));;
123         "0") cidr=$((cidr + 0));;
124      esac
125 done
126 echo $cidr
127
128 }
129
130 function check_yum_installed () {
131     package=$1; shift
132     rpm -q $package >& /dev/null || yum -y install $package
133 }
134
135 function check_yumgroup_installed () {
136     group="$1"; shift
137     yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
138 }
139
140 function prepare_host() {
141         
142     #################### lxc-tools : rebuild as current fedora release has flaws
143     #install development tools
144     check_yumgroup_installed "Development Tools"
145     #install libcap-devel, libvirt
146     check_yum_installed libcap-devel
147     check_yum_installed libvirt
148
149     #retrieve and install lxc from sources 
150     #raw_version=$(lxc-version ||: )
151     #lxc_installed_version=$(echo $raw_version | sed -e 's,.*: ,,')
152     #if [ "$lxc_installed_version" != "$lxc_version" ] ; then
153     if [ ! -f /usr/bin/lxc-ls ] ; then
154         #echo "Expecting version" '['$lxc_version']'
155         #echo "Found version" '['$lxc_installed_version']'
156         echo "Installing lxc ..."
157         cd /root
158         [ -d lxc ] || git clone git://lxc.git.sourceforge.net/gitroot/lxc/lxc 
159         cd lxc
160         git pull
161         git checkout $lxc_version
162         ./autogen.sh
163         ./configure --prefix=/usr --exec-prefix=/usr
164         make
165         make install
166         mkdir -p /usr/var/lib/
167         [ -d /usr/var/lib/lxc ] || ln -s /var/lib/lxc /usr/var/lib/lxc
168         cd $BUILD_DIR
169     fi
170  
171 #    #create a placeholder (just a hack to make lxc works)
172 #    [ -d "/usr/local/var/lib" ] || mkdir -p /usr/local/var/lib
173
174     #################### bride initialization
175     check_yum_installed bridge-utils
176     #Bridge init
177     isInstalled=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
178     if [ "$isInstalled" != "br0" ] ; then
179         bridge_init
180         sleep 5
181     fi
182
183     return 0
184 }
185
186
187
188 function configure_fedora() {
189
190     # disable selinux in fedora
191     mkdir -p $rootfs_path/selinux
192     echo 0 > $rootfs_path/selinux/enforce
193
194    # configure the network 
195
196     cat <<EOF > ${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$IFNAME
197 DEVICE=$IFNAME
198 BOOTPROTO=static
199 ONBOOT=yes
200 HOSTNAME=$HOSTNAME
201 IPADDR=$IP
202 NETMASK=$NETMASK
203 GATEWAY=$GATEWAY
204 NM_CONTROLLED=no
205 TYPE=Ethernet
206 MTU=1500
207 EOF
208
209 # set the hostname
210     cat <<EOF > ${rootfs_path}/etc/sysconfig/network
211 NETWORKING=yes
212 HOSTNAME=$HOSTNAME
213 EOF
214
215     # set minimal hosts
216 #    cat <<EOF > $rootfs_path/etc/hosts
217 #127.0.0.1 localhost $HOSTNAME
218 #EOF
219
220     dev_path="${rootfs_path}/dev"
221     rm -rf $dev_path
222     mkdir -p $dev_path
223     mknod -m 666 ${dev_path}/null c 1 3
224     mknod -m 666 ${dev_path}/zero c 1 5
225     mknod -m 666 ${dev_path}/random c 1 8
226     mknod -m 666 ${dev_path}/urandom c 1 9
227     mkdir -m 755 ${dev_path}/pts
228     mkdir -m 1777 ${dev_path}/shm
229     mknod -m 666 ${dev_path}/tty c 5 0
230     mknod -m 666 ${dev_path}/tty0 c 4 0
231     mknod -m 666 ${dev_path}/tty1 c 4 1
232     mknod -m 666 ${dev_path}/tty2 c 4 2
233     mknod -m 666 ${dev_path}/tty3 c 4 3
234     mknod -m 666 ${dev_path}/tty4 c 4 4
235     mknod -m 600 ${dev_path}/console c 5 1
236     mknod -m 666 ${dev_path}/full c 1 7
237     mknod -m 600 ${dev_path}/initctl p
238     mknod -m 666 ${dev_path}/ptmx c 5 2
239
240     #echo "setting root passwd to $root_password"
241     #echo "root:$root_password" | chroot $rootfs_path chpasswd
242
243     return 0
244 }
245
246
247 function configure_fedora_init() {
248
249     sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
250     sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
251     chroot ${rootfs_path} chkconfig udev-post off
252     chroot ${rootfs_path} chkconfig network on
253 }
254
255
256 function configure_fedora_systemd() {
257
258     unlink ${rootfs_path}/etc/systemd/system/default.target
259     touch ${rootfs_path}/etc/fstab
260     chroot ${rootfs_path} ln -s /dev/null //etc/systemd/system/udev.service
261     chroot ${rootfs_path} ln -s /lib/systemd/system/multi-user.target /etc/systemd/system/default.target
262     #dependency on a device unit fails it specially that we disabled udev
263     sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
264     chroot ${rootfs_path} chkconfig network on
265 }
266
267 function download_fedora() {
268 set -x
269     # check the mini fedora was not already downloaded
270     INSTALL_ROOT=$cache/partial
271     echo $INSTALL_ROOT
272     mkdir -p $INSTALL_ROOT
273     if [ $? -ne 0 ]; then
274         echo "Failed to create '$INSTALL_ROOT' directory"
275         return 1
276     fi
277
278     # download a mini fedora into a cache
279     echo "Downloading fedora minimal ..."
280     YUM="yum --installroot $INSTALL_ROOT -y --nogpgcheck --releasever=$release"
281     PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
282   
283     
284     MIRROR_URL=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os
285     RELEASE_URL="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
286     echo "Fetching from $RELEASE_URL"
287     curl -f "$RELEASE_URL" > $INSTALL_ROOT/fedora-release-$release.noarch.rpm
288     
289     mkdir -p $INSTALL_ROOT/var/lib/rpm
290     rpm --root $INSTALL_ROOT  --initdb
291     rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm
292     echo "$YUM install $PKG_LIST"
293     $YUM install $PKG_LIST
294
295     if [ $? -ne 0 ]; then
296         echo "Failed to download the rootfs, aborting."
297         return 1
298     fi
299
300     mv "$INSTALL_ROOT" "$cache/rootfs"
301     echo "Download complete."
302
303     return 0
304 }
305
306
307 function copy_fedora() {
308 set -x
309     # make a local copy of the minifedora
310     echo -n "Copying rootfs to $rootfs_path ..."
311     mkdir -p $rootfs_path
312     rsync -a $cache/rootfs/ $rootfs_path/
313     return 0
314 }
315
316
317 function update_fedora() {
318 set -x
319     YUM="yum --installroot $cache/rootfs -y --nogpgcheck"
320     $YUM update
321 }
322
323
324 function install_fedora() {
325     set -x
326
327     mkdir -p /var/lock/subsys/
328     (
329         flock -n -x 200
330         if [ $? -ne 0 ]; then
331             echo "Cache repository is busy."
332             return 1
333         fi
334
335         echo "Checking cache download in $cache/rootfs ... "
336         if [ ! -e "$cache/rootfs" ]; then
337             download_fedora
338             if [ $? -ne 0 ]; then
339                 echo "Failed to download 'fedora base'"
340                 return 1
341             fi
342         else
343             echo "Cache found. Updating..."
344             update_fedora
345             if [ $? -ne 0 ]; then
346                 echo "Failed to update 'fedora base', continuing with last known good cache"
347             else
348                 echo "Update finished"
349             fi
350         fi
351
352         echo "Copy $cache/rootfs to $rootfs_path ... "
353         copy_fedora
354         if [ $? -ne 0 ]; then
355             echo "Failed to copy rootfs"
356             return 1
357         fi
358
359         return 0
360
361         ) 200>/var/lock/subsys/lxc
362
363     return $?
364 }
365
366
367 function copy_configuration() {
368
369     mkdir -p $config_path
370     cat <<EOF >> $config_path/config
371 lxc.utsname = $lxc
372 lxc.arch = $arch2
373 lxc.tty = 4
374 lxc.pts = 1024
375 lxc.rootfs = $rootfs_path
376 lxc.mount  = $config_path/fstab
377 #networking
378 lxc.network.type = $lxc_network_type
379 lxc.network.flags = up
380 lxc.network.link = $lxc_network_link
381 lxc.network.name = $IFNAME
382 lxc.network.mtu = 1500
383 lxc.network.ipv4 = $IP/$CIDR
384 #cgroups
385 #lxc.cgroup.devices.deny = a
386 # /dev/null and zero
387 lxc.cgroup.devices.allow = c 1:3 rwm
388 lxc.cgroup.devices.allow = c 1:5 rwm
389 # consoles
390 lxc.cgroup.devices.allow = c 5:1 rwm
391 lxc.cgroup.devices.allow = c 5:0 rwm
392 lxc.cgroup.devices.allow = c 4:0 rwm
393 lxc.cgroup.devices.allow = c 4:1 rwm
394 # /dev/{,u}random
395 lxc.cgroup.devices.allow = c 1:9 rwm
396 lxc.cgroup.devices.allow = c 1:8 rwm
397 lxc.cgroup.devices.allow = c 136:* rwm
398 lxc.cgroup.devices.allow = c 5:2 rwm
399 # rtc
400 lxc.cgroup.devices.allow = c 254:0 rwm
401 lxc.cgroup.devices.allow = b 255:0 rwm
402 EOF
403
404
405
406     cat <<EOF > $config_path/fstab
407 proc            $rootfs_path/proc         proc    nodev,noexec,nosuid 0 0
408 devpts          $rootfs_path/dev/pts      devpts defaults 0 0
409 sysfs           $rootfs_path/sys          sysfs defaults  0 0
410 EOF
411     if [ $? -ne 0 ]; then
412         echo "Failed to add configuration"
413         return 1
414     fi
415
416     return 0
417 }
418
419
420
421
422 # overwrite lxc's internal yum config
423 function configure_yum_in_lxc () {
424     set -x 
425     set -e 
426     trap failure ERR INT
427
428     lxc=$1; shift
429     fcdistro=$1; shift
430     pldistro=$1; shift
431
432     echo "Initializing yum.repos.d in $lxc"
433     rm -f $rootfs_path/etc/yum.repos.d/*
434
435     cat > $rootfs_path/etc/yum.repos.d/building.repo <<EOF
436 [fedora]
437 name=Fedora $release - \$basearch
438 baseurl=http://mirror.onelab.eu/fedora/releases/$release/Everything/\$basearch/os/
439 enabled=1
440 metadata_expire=7d
441 gpgcheck=1
442 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
443
444 [updates]
445 name=Fedora $release - \$basearch - Updates
446 baseurl=http://mirror.onelab.eu/fedora/updates/$release/\$basearch/
447 enabled=1
448 metadata_expire=7d
449 gpgcheck=1
450 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
451 EOF
452     
453     # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
454     # just mention 'none' as the repo url
455     if [ -n "$MYPLC_MODE" -a "$REPO_URL" != "none" ] ; then
456         if [ ! -d $rootfs_path/etc/yum.repos.d ] ; then
457             echo "WARNING : cannot create myplc repo"
458         else
459             # exclude kernel from fedora repos 
460             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
461             for repo in $rootfs_path/etc/yum.repos.d/* ; do
462                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude" 
463             done
464             # the build repo is not signed at this stage
465             cat > $rootfs_path/etc/yum.repos.d/myplc.repo <<EOF
466 [myplc]
467 name= MyPLC
468 baseurl=$REPO_URL
469 enabled=1
470 gpgcheck=0
471 EOF
472         fi
473     fi
474 }    
475
476 # return yum or debootstrap
477 function package_method () {
478     fcdistro=$1; shift
479     case $fcdistro in
480         f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
481         lenny|etch) echo debootstrap ;;
482         *) echo Unknown distro $fcdistro ;;
483     esac 
484 }
485
486 # return arch from debian distro and personality
487 function canonical_arch () {
488     personality=$1; shift
489     fcdistro=$1; shift
490     case $(package_method $fcdistro) in
491         yum)
492             case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
493         debootstrap)
494             case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
495         *)
496             echo Unknown-arch-3 ;;
497     esac
498 }
499
500 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
501 function almost_empty () { 
502     dir="$1"; shift ; 
503     # non existing is fine
504     [ ! -d $dir ] && return 0; 
505     # need to have at most one file
506     count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
507 }
508
509 function setup_lxc() {
510
511     set -x
512     set -e
513     #trap failure ERR INT
514
515     lxc=$1; shift
516     fcdistro=$1; shift
517     pldistro=$1; shift
518     personality=$1; shift
519
520     # create lxc container 
521     copy_configuration
522     if [ $? -ne 0 ]; then
523         echo "failed write configuration file"
524         exit 1
525     fi
526
527     install_fedora
528     if [ $? -ne 0 ]; then
529         echo "failed to install fedora"
530         exit 1
531     fi
532
533     configure_fedora
534     if [ $? -ne 0 ]; then
535         echo "failed to configure fedora for a container"
536         exit 1
537     fi
538
539     type /bin/systemd >/dev/null 2>&1
540     if [ $? -ne 0 ]; then
541         configure_fedora_init
542     else
543         configure_fedora_systemd
544     fi
545
546     # Enable cgroup
547     mkdir $rootfs_path/cgroup
548     
549     # set up resolv.conf
550     cp /etc/resolv.conf $rootfs_path/etc/resolv.conf
551     # and /etc/hosts for at least localhost
552     [ -f $rootfs_path/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $rootfs_path/etc/hosts
553     
554     # ssh access to lxc
555     mkdir $rootfs_path/root/.ssh
556     cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
557     
558     # start container
559     lxc-start -d -n $lxc
560
561     lxc-wait -n $lxc -s RUNNING
562
563     for i in $(seq 1 5); do
564         echo "ssh ..."
565         ssh_up=$(ssh -o "StrictHostKeyChecking no" $IP 'uname -i')
566         [ -n $ssh_up ] && break
567         sleep 3
568     done
569
570     [ -z $ssh_up ] && echo "SSHD in container $lxc is not running"
571      
572
573     # rpm --rebuilddb
574     chroot $rootfs_path rpm --rebuilddb
575     #ssh -o "StrictHostKeyChecking no" $IP "rpm --rebuilddb"
576
577     configure_yum_in_lxc $lxc $fcdistro $pldistro
578
579     return 0
580 }
581
582 function devel_or_vtest_tools () {
583
584     set -x 
585     set -e 
586     trap failure ERR INT
587
588     lxc=$1; shift
589     fcdistro=$1; shift
590     pldistro=$1; shift
591     personality=$1; shift
592
593     pkg_method=$(package_method $fcdistro)
594
595     # check for .pkgs file based on pldistro
596     if [ -n "$VBUILD_MODE" ] ; then
597         pkgsname=devel.pkgs
598     else
599         pkgsname=vtest.pkgs
600     fi
601     pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $pkgsname)
602
603     ### install individual packages, then groups
604     # get target arch - use uname -i here (we want either x86_64 or i386)
605    
606     lxc_arch=$(chroot $rootfs_path uname -i)
607     # on debian systems we get arch through the 'arch' command
608     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path arch)
609
610     packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
611     groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
612
613     case "$pkg_method" in
614         yum)
615             [ -n "$packages" ] && chroot $rootfs_path yum -y install $packages
616             for group_plus in $groups; do
617                 group=$(echo $group_plus | sed -e "s,+++, ,g")
618                 chroot $rootfs_path yum -y groupinstall "$group"
619             done
620             # store current rpm list in /init-lxc.rpms in case we need to check the contents
621             chroot $rootfs_path rpm -aq > $rootfs_path/init-lxc.rpms
622             ;;
623         debootstrap)
624             chroot $rootfs_path apt-get update
625             for package in $packages ; do 
626                 chroot $rootfs_path  apt-get install -y $package 
627             done
628             ### xxx todo install groups with apt..
629             ;;
630         *)
631             echo "unknown pkg_method $pkg_method"
632             ;;
633     esac
634
635     return 0
636 }
637
638 function post_install () {
639     if [ -n "$VBUILD_MODE" ] ; then
640         post_install_vbuild "$@" 
641     else
642         post_install_myplc "$@"
643     fi
644     # setup localtime from the host
645     lxc=$1; shift 
646     cp /etc/localtime $rootfs_path/etc/localtime
647 }
648
649 function post_install_vbuild () {
650
651     set -x 
652     set -e 
653     trap failure ERR INT
654
655     lxc=$1; shift
656     personality=$1; shift
657
658 ### From myplc-devel-native.spec
659 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
660     cat << EOF | chroot $rootfs_path bash -x
661     # set up /dev/loop* in lxc
662     for i in \$(seq 0 255) ; do
663         mknod -m 640 /dev/loop\$i b 7 \$i
664     done
665     
666     # create symlink for /dev/fd
667     [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
668
669     # modify /etc/rpm/macros to not use /sbin/new-kernel-pkg
670     sed -i 's,/sbin/new-kernel-pkg:,,' /etc/rpm/macros
671     if [ -h "/sbin/new-kernel-pkg" ] ; then
672         filename=\$(readlink -f /sbin/new-kernel-pkg)
673         if [ "\$filename" == "/sbin/true" ] ; then
674                 echo "WARNING: /sbin/new-kernel-pkg symlinked to /sbin/true"
675                 echo "\tmost likely /etc/rpm/macros has /sbin/new-kernel-pkg declared in _netsharedpath."
676                 echo "\tPlease remove /sbin/new-kernel-pkg from _netsharedpath and reintall mkinitrd."
677                 exit 1
678         fi
679     fi
680     
681     # customize root's prompt
682     cat << PROFILE > /root/.profile
683 export PS1="[$lxc] \\w # "
684 PROFILE
685
686     uid=2000
687     gid=2000
688     
689     # add a "build" user to the system
690     builduser=\$(grep "^build:" /etc/passwd | wc -l)
691     if [ \$builduser -eq 0 ] ; then
692         groupadd -o -g \$gid build;
693         useradd -o -c 'Automated Build' -u \$uid -g \$gid -n -M -s /bin/bash build;
694     fi
695
696 # Allow build user to build certain RPMs as root
697     if [ -f /etc/sudoers ] ; then
698         buildsudo=\$(grep "^build.*ALL=(ALL).*NOPASSWD:.*ALL"  /etc/sudoers | wc -l)
699         if [ \$buildsudo -eq 0 ] ; then
700             echo "build   ALL=(ALL)       NOPASSWD: ALL" >> /etc/sudoers
701         fi
702         sed -i 's,^Defaults.*requiretty,#Defaults requiretty,' /etc/sudoers
703     fi
704 #
705 EOF
706
707 }
708
709 function post_install_myplc  () {
710     set -x 
711     set -e 
712     trap failure ERR INT
713
714     lxc=$1; shift
715     personality=$1; shift
716
717 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
718     cat << EOF | chroot $rootfs_path bash -x
719
720     # create /etc/sysconfig/network if missing
721     [ -f /etc/sysconfig/network ] || echo NETWORKING=yes > /etc/sysconfig/network
722
723     # create symlink for /dev/fd
724     [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
725
726     # turn off regular crond, as plc invokes plc_crond
727     chkconfig crond off
728
729     # take care of loginuid in /etc/pam.d 
730     sed -i "s,#*\(.*loginuid.*\),#\1," /etc/pam.d/*
731
732     # customize root's prompt
733     cat << PROFILE > /root/.profile
734 export PS1="[$lxc] \\w # "
735 PROFILE
736
737 EOF
738 }
739
740 function usage () {
741     set +x 
742     echo "Usage: $COMMAND_VBUILD [options] lxc-name"
743     echo "Usage: $COMMAND_MYPLC [options] lxc-name repo-url [ -- lxc-options ]"
744     echo "Description:"
745     echo "   This command creates a fresh lxc instance, for building, or running, myplc"
746     echo "Supported options"
747     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
748     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
749     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
750     echo " -i ifname: determines ip and netmask attached to ifname, and passes it to the lxc"
751     echo "-- lxc-options"
752     echo "  --netdev : interface to be defined inside lxc"
753     echo "  --interface : IP to be defined for the lxc"
754     echo "  --hostname : Hostname to be defined for the lxc"
755     echo "With $COMMAND_MYPLC you can give 'none' as the URL, in which case"
756     echo "   myplc.repo does not get created"
757     exit 1
758 }
759
760 ### parse args and 
761 function main () {
762
763     #set -e
764     #trap failure ERR INT
765
766     case "$COMMAND" in
767         $COMMAND_VBUILD)
768             VBUILD_MODE=true ;;
769         $COMMAND_MYPLC)
770             MYPLC_MODE=true;;
771         *)
772             usage ;;
773     esac
774
775     VERBOSE=
776     RESISTANT=""
777     IFNAME=""
778     LXC_OPTIONS=""
779     while getopts "f:d:p:i:" opt ; do
780         case $opt in
781             f) fcdistro=$OPTARG;;
782             d) pldistro=$OPTARG;;
783             p) personality=$OPTARG;;
784             i) IFNAME=$OPTARG;;
785             *) usage ;;
786         esac
787     done
788         
789     shift $(($OPTIND - 1))
790
791     # parse fixed arguments
792     [[ -z "$@" ]] && usage
793     lxc=$1 ; shift
794     if [ -n "$MYPLC_MODE" ] ; then
795         [[ -z "$@" ]] && usage
796         REPO_URL=$1 ; shift
797     fi
798
799     # parse vserver options
800     if [[ -n "$@" ]] ; then
801         if [ "$1" == "--" ] ; then
802             shift
803             LXC_OPTIONS="$@"
804         else
805             usage
806         fi
807     fi
808
809     eval set -- "$LXC_OPTIONS"
810
811     while true
812      do
813         case "$1" in
814              --netdev)      IFNAME=$2; shift 2;;
815              --interface)   IP=$2; shift 2;;
816              --hostname)    HOSTNAME=$2; shift 2;;
817              *)             break ;;
818         esac
819       done
820
821    
822     if [ -n "$VBUILD_MODE" ] ; then
823         [ -z "$IFNAME" ] && IFNAME=$DEFAULT_IFNAME
824         [ -z "$HOSTNAME" ] && HOSTNAME=$lxc
825     fi
826
827     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
828     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
829     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
830     
831     release=$(echo $fcdistro | cut -df -f2)
832
833     if [ "$personality" == "linux32" ]; then
834         arch=i386
835         arch2=x86
836     elif [ "$personality" == "linux64" ]; then
837         arch=x86_64
838         arch2=x86_64
839     else
840         echo "Unknown personality: $personality"
841     fi
842
843     # need lxc installed before we can run lxc-ls
844     # need bridge installed
845     prepare_host    
846
847     if [ -n "$VBUILD_MODE" ] ; then
848
849         # Bridge IP affectation
850         x=$(echo $personality | cut -dx -f2)
851         y=$(echo $fcdistro | cut -df -f2)
852         z=$(($x + $y))
853
854         IP="192.168.122.$z"
855         NETMASK="255.255.255.0"
856         GATEWAY="192.168.122.1"
857         
858         lxc_network_type=veth
859         lxc_network_link=virbr0
860         echo "the IP address of container $lxc is $IP "
861     else
862         [[ -z "$REPO_URL" ]] && usage
863         [[ -z "$IP" ]] && usage
864         NETMASK=$(ifconfig br0 | grep 'inet addr' | awk '{print $4}' | sed -e 's/.*://')
865         GATEWAY=$(route -n | grep 'UG' | awk '{print $2}')
866         [[ -z "$HOSTNAME" ]] && usage
867         lxc_network_type=veth
868         lxc_network_link=br0
869     fi
870
871     CIDR=$(cidr_notation $NETMASK)
872     
873
874     if [ "$(id -u)" != "0" ]; then
875           echo "This script should be run as 'root'"
876           exit 1
877     fi
878
879     path=/var/lib/lxc
880     rootfs_path=$path/$lxc/rootfs
881     config_path=$path/$lxc
882     cache_base=/var/cache/lxc/fedora/$arch
883     cache=$cache_base/$release
884     root_password=root
885     
886     # check whether the rootfs directory is created to know if the container exists
887     # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
888     [ -d $rootfs_path ] && { echo "container $lxc already exists - exiting" ; exit 1 ; }
889
890     setup_lxc $lxc $fcdistro $pldistro $personality 
891
892     devel_or_vtest_tools $lxc $fcdistro $pldistro $personality
893
894     post_install $lxc $personality
895     
896
897     echo $COMMAND Done
898 }
899
900 main "$@"